(define-module (bible-tools count-words)
  #:use-module (bible-tools bible-tools)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-26)
  #:use-module (srfi srfi-171)
  #:use-module (srfi srfi-171 gnu)
  #:export (count-words))

(define (split/stuff str)
  (define (mapcan f l) (apply append (map f l)))
  (define (split-curry char) (cut string-split <> char))
  (let ((splits (map split-curry '(#\, #\: #\. #\! #\? #\; #\< #\>))))
    (fold mapcan (string-split str #\space) splits)))

(define (counter . args)
  (cond ((null? args) '())
	((< (length args) 2) (car args))
	(else (let ((val (assoc (cadr args) (car args))))
		(acons (cadr args)
		       (1+ (if val (cdr val) 0)) (car args))))))

(define (count verse result)
  (list-transduce clean-strings
		  counter
		  result (split/stuff verse)))

(define (co f g) (lambda (v w) (f (g v) (g w))))

(define count-words
  (compose (cut sort <> (co > cdr))
	   (cut delete-duplicates <> (co equal? car))
	   (cut fold count '() <>)))
